#ifndef __NR_read
#define __NR_read 0
#endif
#ifndef __NR_mmap
#define __NR_mmap 9
#endif
#ifndef __NR_open
#define __NR_open 2
#endif
#ifndef __NR_lseek
#define __NR_lseek 8
#endif

#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/mount.h>
#include <sys/prctl.h>
#include <sys/resource.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <assert.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#include <pthread.h>
#include <setjmp.h>
#include <signal.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

static uintptr_t execute_syscall(int nr, uintptr_t a0, uintptr_t a1,
                                 uintptr_t a2, uintptr_t a3,
                                 uintptr_t a4, uintptr_t a5,
                                 uintptr_t a6, uintptr_t a7,
                                 uintptr_t a8)
{
  switch (nr) {
  default:
    return syscall(nr, a0, a1, a2, a3, a4, a5);
  }
}

void test()
{
  long r[4];
  const char *filename = "file0";
  r[0] = execute_syscall(__NR_mmap, 0x20000000ul, 0x77c000ul, 0x3ul,
                         0x32ul, 0xfffffffffffffffful, 0x0ul, 0, 0, 0);
  printf("mmap()=%ld errno=%d\n", r[0], errno);
  r[1] = execute_syscall(__NR_open, (uintptr_t)filename, O_DIRECT | O_CREAT, 0x0ul, 0, 0,
                         0, 0, 0, 0);
  printf("open()=%ld errno=%d\n", r[1], errno);
  r[2] = execute_syscall(__NR_lseek, r[1], 0, SEEK_END, 0, 0, 0, 0, 0, 0);
  printf("lseek()=%ld errno=%d\n", r[2], errno);
  r[3] = execute_syscall(__NR_read, r[1], 0x20000000ul, 0x1ul, 0, 0, 0,
                         0, 0, 0);
  printf("read()=%ld errno=%d\n", r[3], errno);
}

int main()
{
  test();
  return 0;
}
